<?php

defined('_JEXEC') or die('Restricted access');

if (! class_exists('lib_common_newebpay')) {
   require_once(JPATH_SITE. DS .'plugins'. DS .'hikashoppayment'. DS .'newebpay'. DS .'lib_common_newebpay.php');
}

class plgHikashoppaymentNewebPay extends hikashopPaymentPlugin {

    private $hashKey, $hashIV;
    var $accepted_currencies = array(
        'EUR', 'USD', 'GBP', 'HKD', 'SGD', 'JPY', 'CAD', 'AUD', 'CHF', 'DKK',
        'SEK', 'NOK', 'ILS', 'MYR', 'NZD', 'TRY', 'AED', 'MAD', 'QAR', 'SAR',
        'TWD', 'THB', 'CZK', 'HUF', 'SKK', 'EEK', 'BGN', 'PLN', 'ISK', 'INR',
        'LVL', 'KRW', 'ZAR', 'RON', 'HRK', 'LTL', 'JOD', 'OMR', 'RSD', 'TND', 'CNY',
    );
    var $multiple = true;
    var $name = 'newebpay';
    var $pluginConfig = array(
        'NewebPayMPG_test_mode' => array('測試模式(Test_Mode)', 'boolean', '0'),
        'NewebPay_merchant_id' => array('商店代號(Merchant ID)', 'input'),
        'NewebPayMPG_hash_key' => array('加密傳送KEY (Hash Key)', 'input'),
        'NewebPayMPG_hash_iv' => array('加密傳送IV (Hash IV)', 'input'),
        'NewebPayMPG_finish_status_id' => array('完成付款狀態(Order Finish Status)', 'orderstatus'),
        'NewebPayMPG_fail_status_id' => array('匯款失敗狀態(Credit or WebAtm Order Fail Status)', 'orderstatus'),
        'NewebPayMPG_lang_type' => array('支付頁語系(language)', 'list', array('zh-tw' => 'zh-tw', 'en' => 'en')),
        'NewebPayMPG_clientBack_url' => array('結帳頁返回網址(Go Back Url)', 'input')
    );

    function onAfterOrderConfirm(&$order, &$methods, $method_id) {
        // 組成 html
        $this->payment_html = $this->_getPaymentHtml($order);

        // 是否為測試模式
        $this->htmlAction = ($methods[$order->order_payment_id]->payment_params->NewebPayMPG_test_mode) ? 'https://ccore.newebpay.com/MPG/mpg_gateway' : 'https://core.newebpay.com/MPG/mpg_gateway';

        // newebpay 需要傳遞參數
        $this->params = $this->_getNewebPayParams($order, $methods[$method_id]);

        return $this->showPage('end');
    }

    function onPaymentNotification(&$statuses) {
        
        $config = JFactory::getConfig();

        mb_internal_encoding('utf-8');

        $db = JFactory::getDBO();
        $db->setQuery('SELECT payment_params FROM '.$config['dbprefix'].'hikashop_payment WHERE payment_type=\'newebpay\'');
        $db_data = $db->loadObject();

        $newebpay_configs = unserialize($db_data->payment_params);  //unserialize後為object
        // 交易狀態
        $result = $_REQUEST;

        $this->lib_common = new lib_common_newebpay;
        $result = $this->lib_common
            ->setHashKey(trim($newebpay_configs->NewebPayMPG_hash_key))
            ->setHashIv(trim($newebpay_configs->NewebPayMPG_hash_iv))
            ->runReturnDataDecrypt($result);

        // 取得該筆交易資料
        $db->setQuery("SELECT * FROM ".$config['dbprefix']."hikashop_order WHERE order_number = '" . $result['MerchantOrderNo'] . "'");
        $order_info = $db->loadObject();

        switch ($_REQUEST['retrun']) {
            case 'return':
                $this->proccessReturn($order_info, $newebpay_configs);
            break;
            
            case 'notify':
                $this->proccessNotify($order_info, $newebpay_configs);
            break;
        }
        return true;
    }

    private function proccessReturn($order_info, $newebpay_configs)
    {
        if (! isset($order_info)) return false;
        if (! isset($newebpay_configs)) return false;

        $order_back = $this->lib_common
            ->setLocalOrderPrice(round($order_info->order_full_price))
            ->checkReturnOrderCondition('notify');

        if (! $order_back['status']) {
            //fail
            $this->redirect(JURI::root() . "index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id=$order_info->order_id");
            exit();
        }

        //Success
        $this->redirect(JURI::root() . "index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id=$order_info->order_id");
        exit();
    }

    private function proccessNotify($order_info, $newebpay_configs)
    {
        if (! isset($order_info)) return false;
        if (! isset($newebpay_configs)) return false;

        $order_back = $this->lib_common
            ->setLocalOrderPrice(round($order_info->order_full_price))
            ->checkReturnOrderCondition('notify');

        // 取時間做檔名 (YYYYMMDD)
        // $file_name = 'newebpay_' . date('Ymd', time()) . '.txt';

        // 檔案路徑
        $file_path = __DIR__ . "/order_log/";

        if (! $order_back['status']) {
            $this->modifyOrder($order_info->order_id, $newebpay_configs->NewebPayMPG_fail_status_id, true, true);
            echo $order_back['comment'];
            $this->lib_common->write_log_in_file($file_path, $order_back['comment']);
            exit();
        }
        if ($order_info->order_status != $newebpay_configs->NewebPayMPG_finish_status_id) {
            $this->modifyOrder($order_info->order_id, $newebpay_configs->NewebPayMPG_finish_status_id, true, true);
        }

        $this->lib_common->write_log_in_file($file_path, $order_back['comment']);
        exit();
    }

    /**
     * 組成 html
     *
     * @param obj $order_info 訂購的相關資訊
     */
    protected function _getPaymentHtml($order_info) {
        $result = array(
            'httpDomain' => JURI::root(),
            'order_id' => $order_info->order_id,
            'order_number' => $order_info->order_number,
            'order_payment_method' => $order_info->order_payment_method,
            'customer_email' => $order_info->customer->user_email,
            'shipping_address' => $this->_getAddress(isset($order_info->cart->shipping_address) ? $order_info->cart->shipping_address : $order_info->shipping_address),
            'products' => $this->_getProducts(isset($order_info->cart->products) ? $order_info->cart->products : $order_info->products, $order_info->order_tax_info),
            'shipping_price' => $order_info->order_shipping_price,
            'discount_price' => $order_info->order_discount_price,
            'full_price' => round($order_info->order_full_price)
        );
        return $result;
    }

    /**
     * 取得地址資訊
     *
     * @param obj $address_info 地址資訊
     */
    protected function _getAddress($address_info) {

        if (is_array($address_info->address_state)) {
            $address_info->address_state = str_replace('_', ' ', $address_info->address_state[1]);
        }

        if (is_array($address_info->address_country)) {
            $address_info->address_country = str_replace('_', ' ', $address_info->address_country[0]);
        }

        $result = array(
            'title' => $address_info->address_title,
            'name' => $address_info->address_lastname . ' ' . $address_info->address_firstname,
            'street' => $address_info->address_street,
            'street' => $address_info->address_street,
            'post_code' => $address_info->address_post_code,
            'city' => $address_info->address_city,
            'state' => $address_info->address_state,
            'country' => $address_info->address_country,
            'telephone' => $address_info->address_telephone
        );

        return $result;
    }

    /**
     * 取得訂單貨物資訊
     *
     * @param obj   $product_infos 訂單貨物資訊
     * @param array $tax_info      稅率資訊
     */
    protected function _getProducts($product_infos, $tax_info) {
        $result['total_price'] = 0;
        $result['total_tax'] = '';
        $result['tax_name'] = '';
        if (! empty($tax_info))  {
            $result = array(
                'total_price' => 0,
                'total_tax' => round($tax_info[key($tax_info)]->tax_amount),
                'tax_name' => key($tax_info)
            );
        }
        foreach ($product_infos as $key => $obj) {
            $result['orders'][$key] = array();
            $result['orders'][$key]['product_name'] = $obj->order_product_name;
            $result['orders'][$key]['product_quantity'] = $obj->order_product_quantity;
            $result['orders'][$key]['product_price'] = $obj->order_product_price;
            $result['orders'][$key]['product_tax'] = $obj->order_product_tax;

            // 計算總額
            $result['total_price'] += $obj->order_product_quantity * $obj->order_product_price + $obj->order_product_quantity * $obj->order_product_tax;
        }

        return $result;
    }

    /**
     * newebpay 需要傳遞參數
     *
     * @param obj $order_info   訂購的相關資訊
     * @param obj $newebpayConfig newebpay的相關資訊
     *
     * @return array
     */
    protected function _getNewebPayParams($order_info, $newebpayConfig) {
        $this->lib_common = new lib_common_newebpay;
        $this->lib_common
            ->setHashKey(trim($newebpayConfig->payment_params->NewebPayMPG_hash_key))
            ->setHashIv(trim($newebpayConfig->payment_params->NewebPayMPG_hash_iv))
            ->setMerchantId(trim($newebpayConfig->payment_params->NewebPay_merchant_id))
            ->setOrderNo($order_info->order_number)
            ->setOrderAmt(round($order_info->order_full_price))
            ->setOrderItemName($this->genetateItemDescByOrder($order_info))
            ->setEmail($order_info->customer->user_email)
            ->setLoginType('0')
            ->setClientBackURL(trim($newebpayConfig->payment_params->NewebPayMPG_clientBack_url))
            ->setReturnURL(JURI::root() . "index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=newebpay&tmpl=component&lang=CURRENT_LANG_CODE&retrun=return")
            ->setNotifyURL(JURI::root() . "index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=newebpay&tmpl=component&lang=CURRENT_LANG_CODE&retrun=notify")
            ->setLangType($newebpayConfig->payment_params->NewebPayMPG_lang_type)
            ->setCartVersion('Hika_Shop_v1.0.0');
        return $this->lib_common->runOnlyFormData();
    }

    /**
     * 取得檢查碼
     *
     * @param array  $params    訂單參數
     *
     * @return string checkValue
     */
    protected function _getCheckValue($params) {
        // 要重新排序的參數
        $sortArray = array(
            'MerchantID' => $params['MerchantID'],
            'TimeStamp' => $params['TimeStamp'],
            'MerchantOrderNo' => $params['MerchantOrderNo'],
            'Version' => $params['Version'],
            'Amt' => $params['Amt'],
        );

        ksort($sortArray);

        $check_merstr = http_build_query($sortArray, '', '&');

        $checkValue_str = 'HashKey=' . $this->hashKey . '&' . $check_merstr . '&HashIV=' . $this->hashIV;

        return strtoupper(hash("sha256", $checkValue_str));
    }

    function onPaymentConfigurationSave(&$element) {
        return true;
    }

    function getPaymentDefaultValues(&$element) {
        $element->payment_name = 'newebpay';
        $element->payment_description = 'NewebPay Description';
        $element->payment_images = 'None';
    }

    function redirect($url, $permanent = false)
    {
        if (headers_sent() === false)
        {
            header('Location: ' . $url, true, ($permanent === true) ? 301 : 302);
        }

        exit();
    }
    private function genetateItemDescByOrder($order)
    {
        if (! isset($order)) return 'NewebPay Order';
        $item_desc = '';
        foreach ($order->cart->products as $_ind => $product) {
            if (empty($order->cart->products[$_ind+1])) {
                $item_desc.= $product->order_product_name .' x '.$product->order_product_quantity.'';
                break;
            }
            $item_desc.= $product->order_product_name .' x '.$product->order_product_quantity.', ';
        }
        return $item_desc;
    }
}
